Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/ClassificationImportTypeDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/ClassificationImportTypeDialog.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/ClassificationImportTypeDialog.cs	(revision 9021)
@@ -32,5 +32,5 @@
         return new ClassificationImportType() {
           Shuffle = ShuffleDataCheckbox.Checked,
-          Training = TrainingTestTrackBar.Value,
+          TrainingPercentage = TrainingTestTrackBar.Value,
           TargetVariable = (String)TargetVariableComboBox.SelectedValue,
           UniformlyDistributeClasses = UniformDistributionOfClassesCheckbox.Checked
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportTypeDialog.cs	(revision 9021)
@@ -57,5 +57,5 @@
         return new DataAnalysisImportType() {
           Shuffle = ShuffleDataCheckbox.Checked,
-          Training = TrainingTestTrackBar.Value
+          TrainingPercentage = TrainingTestTrackBar.Value
         };
       }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/RegressionImportTypeDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/RegressionImportTypeDialog.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/RegressionImportTypeDialog.cs	(revision 9021)
@@ -30,5 +30,5 @@
         return new RegressionImportType() {
           Shuffle = ShuffleDataCheckbox.Checked,
-          Training = TrainingTestTrackBar.Value,
+          TrainingPercentage = TrainingTestTrackBar.Value,
           TargetVariable = (String)TargetVariableComboBox.SelectedValue
         };
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/TimeSeriesPrognosisImportTypeDialog.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/TimeSeriesPrognosisImportTypeDialog.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/TimeSeriesPrognosisImportTypeDialog.cs	(revision 9021)
@@ -31,5 +31,5 @@
           //time series prognosis problems shall not be shuffled
           Shuffle = false,
-          Training = TrainingTestTrackBar.Value,
+          TrainingPercentage = TrainingTestTrackBar.Value,
           TargetVariable = (String)TargetVariableComboBox.SelectedValue
         };
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/CSV/ClassifiactionCSVInstanceProvider.cs	(revision 9021)
@@ -91,5 +91,5 @@
 
     protected override IClassificationProblemData ImportData(string path, ClassificationImportType type, TableFileParser csvFileParser) {
-      int trainingPartEnd = (csvFileParser.Rows * type.Training) / 100;
+      int trainingPartEnd = (csvFileParser.Rows * type.TrainingPercentage) / 100;
       List<IList> values = csvFileParser.Values;
       if (type.Shuffle) {
@@ -97,5 +97,5 @@
         if (type.UniformlyDistributeClasses) {
           values = Shuffle(values, csvFileParser.VariableNames.ToList().FindIndex(x => x.Equals(type.TargetVariable)),
-                           type.Training, out trainingPartEnd);
+                           type.TrainingPercentage, out trainingPartEnd);
         }
       }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/CSV/ClusteringCSVInstanceProvider.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/CSV/ClusteringCSVInstanceProvider.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Clustering/CSV/ClusteringCSVInstanceProvider.cs	(revision 9021)
@@ -100,5 +100,5 @@
       // turn of input variables that are constant in the training partition
       var allowedInputVars = new List<string>();
-      int trainingPartEnd = (csvFileParser.Rows * type.Training) / 100;
+      int trainingPartEnd = (csvFileParser.Rows * type.TrainingPercentage) / 100;
       var trainingIndizes = Enumerable.Range(0, trainingPartEnd);
       if (trainingIndizes.Count() >= 2) {
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisImportType.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisImportType.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisImportType.cs	(revision 9021)
@@ -23,5 +23,5 @@
   public class DataAnalysisImportType {
     public bool Shuffle { get; set; }
-    public int Training { get; set; }
+    public int TrainingPercentage { get; set; }
   }
 }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/CSV/RegressionCSVInstanceProvider.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/CSV/RegressionCSVInstanceProvider.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/CSV/RegressionCSVInstanceProvider.cs	(revision 9021)
@@ -97,5 +97,5 @@
       // turn of input variables that are constant in the training partition
       var allowedInputVars = new List<string>();
-      int trainingPartEnd = (csvFileParser.Rows * type.Training) / 100;
+      int trainingPartEnd = (csvFileParser.Rows * type.TrainingPercentage) / 100;
       trainingPartEnd = trainingPartEnd > 0 ? trainingPartEnd : 1;
       var trainingIndizes = Enumerable.Range(0, trainingPartEnd);
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/TimeSeries/CSV/TimeSeriesPrognosisCSVInstanceProvider.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/TimeSeries/CSV/TimeSeriesPrognosisCSVInstanceProvider.cs	(revision 9019)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/TimeSeries/CSV/TimeSeriesPrognosisCSVInstanceProvider.cs	(revision 9021)
@@ -87,5 +87,5 @@
       // turn of input variables that are constant in the training partition
       var allowedInputVars = new List<string>();
-      int trainingPartEnd = (csvFileParser.Rows * type.Training) / 100;
+      int trainingPartEnd = (csvFileParser.Rows * type.TrainingPercentage) / 100;
       trainingPartEnd = trainingPartEnd > 0 ? trainingPartEnd : 1;
       var trainingIndizes = Enumerable.Range(0, trainingPartEnd);