Index: trunk/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx
===================================================================
--- trunk/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx	(revision 9022)
+++ trunk/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx	(revision 9023)
@@ -15,7 +15,10 @@
   <form id="form1" runat="server">
   <div>
-    Available Cores:
+      Overall Available Cores:
+    <asp:Label ID="overallAvailableCoresLabel" runat="server" />
+      <br />
+      Available Cores (real):
     <asp:Label ID="availableCoresLabel" runat="server" />
-    <br />
+      <br />
     Used Cores / Calculating Jobs:
     <asp:Label ID="usedCoresLabel" runat="server" />
@@ -24,22 +27,26 @@
     <asp:Label ID="waitingJobsLabel" runat="server" />
     <br />
+      Overall
     Avg. CPU Utilization:
+    <asp:Label ID="overallCpuUtilizationLabel" runat="server" />
+      <br />
+      Real Avg. CPU Utilization:
     <asp:Label ID="cpuUtilizationLabel" runat="server" />
-      <br />
+      &nbsp;<br />
     Slaves (CPU Utilization):
     <asp:Label ID="slavesLabel" runat="server" />
       <br />
       <br />
-      Number of calculating tasks by user:<asp:Table ID="calculatingTasksByUserTable" runat="server" GridLines="Both">
-          <asp:TableRow runat="server">
+      Number of Calculating Tasks by User:<asp:Table ID="calculatingTasksByUserTable" runat="server" GridLines="Both">
+          <asp:TableRow runat="server" BackColor="#CCCCCC">
               <asp:TableCell runat="server" Font-Bold="False">User</asp:TableCell>
-              <asp:TableCell runat="server" Font-Bold="False">Nr. of tasks</asp:TableCell>
+              <asp:TableCell runat="server" Font-Bold="False">Nr. of Tasks</asp:TableCell>
           </asp:TableRow>
       </asp:Table>
       <br />
-      Number of waiting tasks by user:<asp:Table ID="waitingTasksByUserTable" runat="server" GridLines="Both">
-          <asp:TableRow runat="server">
+      Number of Waiting Tasks by User:<asp:Table ID="waitingTasksByUserTable" runat="server" GridLines="Both">
+          <asp:TableRow runat="server" BackColor="#CCCCCC">
               <asp:TableCell runat="server" Font-Bold="False">User</asp:TableCell>
-              <asp:TableCell runat="server" Font-Bold="False">Nr. of tasks</asp:TableCell>
+              <asp:TableCell runat="server" Font-Bold="False">Nr. of Tasks</asp:TableCell>
           </asp:TableRow>
       </asp:Table>
Index: trunk/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx.cs
===================================================================
--- trunk/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx.cs	(revision 9022)
+++ trunk/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Status.aspx.cs	(revision 9023)
@@ -66,7 +66,9 @@
     }, false, false);
 
-    int currentlyAvailableCores = onlineSlaves.Where(s => s.Cores.HasValue).Sum(s => s.Cores.Value);
-    int currentlyUsedCores = currentlyAvailableCores - onlineSlaves.Where(s => s.FreeCores.HasValue).Sum(s => s.FreeCores.Value);
+    int overallCurrentlyAvailableCores = onlineSlaves.Where(s => s.Cores.HasValue).Sum(s => s.Cores.Value);
+    int currentlyAvailableCores = onlineSlaves.Where(s => s.Cores.HasValue && s.IsAllowedToCalculate).Sum(s => s.Cores.Value);
+    int currentlyUsedCores = overallCurrentlyAvailableCores - onlineSlaves.Where(s => s.FreeCores.HasValue).Sum(s => s.FreeCores.Value);
     
+    this.overallAvailableCoresLabel.Text = overallCurrentlyAvailableCores.ToString();
     this.availableCoresLabel.Text = currentlyAvailableCores.ToString();
     this.usedCoresLabel.Text = currentlyUsedCores.ToString();
@@ -75,5 +77,6 @@
     slavesLabel.Text = string.Join(", ", onlineSlaves.Select(x => string.Format("<a href=\"?resource={0}\">{0}</a> ({1} %)", x.Name, Math.Round(x.CpuUtilization, 2))));
 
-    cpuUtilizationLabel.Text = (onlineSlaves.Count() > 0 ? Math.Round(onlineSlaves.Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
+    overallCpuUtilizationLabel.Text = (onlineSlaves.Count() > 0 ? Math.Round(onlineSlaves.Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
+    cpuUtilizationLabel.Text = (onlineSlaves.Count() > 0 ? Math.Round(onlineSlaves.Where(x => x.IsAllowedToCalculate).Average(s => s.CpuUtilization), 2).ToString() : "0.0") + " %";
 
     DT.Statistics[] stats = new DT.Statistics[0];    